"""
Django settings for information_broker project.

Generated by 'django-admin startproject' using Django 1.11.7.

For more information on this file, see
https://docs.djangoproject.com/en/1.11/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.11/ref/settings/
"""

import os

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
PROJECT_DIR = os.path.dirname(os.path.abspath(__file__))

STATIC_ROOT = os.path.join(BASE_DIR, 'static')
IB_URL = 'http://127.0.0.1:5000/'
TOKEN_URL = 'http://localhost:5000'
# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.11/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'o_zm@6e!y_6yozwj$*$%v(c8n%+e8hjyk$@l@83ygtpuhkaj_7'
ACCESS_TOKEN = ''

CORS_ORIGIN_ALLOW_ALL = True
CORS_ALLOW_HEADERS = (
    'accept',
    'accept-encoding',
    'authorization',
    'content-type',
    'dnt',
    'origin',
    'user-agent',
    'x-csrftoken',
    'x-requested-with',
)

CLIENT_ID = 'baU8LWi0SABAz27dAMl9GuFNP3MZSTnYB7CDHtJk'
CLIENT_SECRET = 'P6Pbo6Tnm9X48kXGAhx1kMJyZzE8rFE0yheXv80Mek6DDVUd8zppYqUjOLB8j6ZtJuIILO2ojpfWXLn7QO3Do5etRs3wZBlVmu3wMeyOpflXphSJoKFTZoBS0xEGN4EG'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True
# ci check6786788994676
ALLOWED_HOSTS = ['*', ]

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    # Native apps
    'ib',
    'rest_framework',
    'rest_framework.authtoken',
    # 3rd party apps
    'corsheaders',
    'cachalot',
    'drf_yasg',
]
USER_TOKEN_KEY_PREFIX = 'token_user_'
MIDDLEWARE = [
    # 'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.contrib.auth.middleware.SessionAuthenticationMiddleware',
    'oauth2_provider.middleware.OAuth2TokenMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'corsheaders.middleware.CorsMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'information_broker.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'information_broker.wsgi.application'

# DATABASES = {
#     'default': {
#         'ENGINE': 'django.db.backends.postgresql',
#         'NAME': 'information_broker',
#         'USER': 'information_broker',
#         'PASSWORD': 'xyXdSM2DW5HPkJG8vV9CezXLmhtpyuLc',
#         'HOST': '192.168.1.206',
#         'PORT': '5432',
#     }
# }

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': os.path.join(BASE_DIR, 'db.sqlite3')
    }
}

# Password validation
# https://docs.djangoproject.com/en/1.11/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

# Internationalization
# https://docs.djangoproject.com/en/1.11/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.11/howto/static-files/
# LOGIN_URL = 'http://localhost:8000/admin/'

# LOGIN_URL = 'rest_framework:login'
# LOGOUT_URL = 'rest_framework:logout'
STATIC_URL = '/static/'

USE_SESSION_AUTH = True

# ==================================
#   CACHE SETTINGS
# ==================================
ORM_CACHE_TIMEOUT = 2592000
CACHES = {
    'default': {
        'BACKEND': 'django.core.cache.backends.memcached.MemcachedCache',
        'LOCATION': '127.0.0.1:11211',
        'TIMEOUT': ORM_CACHE_TIMEOUT,
    }
}

# ==================================
#   CACHALOT SETTINGS
# ==================================
CACHALOT_ENABLED = True
CACHALOT_CACHE = 'default'
CACHALOT_CACHE_RANDOM = True
CACHALOT_INVALIDATE_RAW = True
CACHALOT_TIMEOUT = ORM_CACHE_TIMEOUT

# ==================================
#   REST FRAMEWORK SETTINGS
# ==================================
REST_FRAMEWORK = {
    'DEFAULT_AUTHENTICATION_CLASSES': [
        'rest_framework.authentication.TokenAuthentication',  # <-- And here
    ],
    'DEFAULT_PERMISSION_CLASSES': (
        'rest_framework.permissions.IsAuthenticated',
    )
}

# ==================================
#   SWAGGER SETTINGS
# ==================================
SWAGGER_SETTINGS = {
    'SUPPORTED_SUBMIT_METHODS': [
        'get',
        'post',
        'put',
        'patch',
        'delete',
    ],
    'SECURITY_DEFINITIONS': {
        'Bearer': {
            'description': "",
            'type': 'apiKey',
            'name': 'Authorization',
            'in': 'header'
        },
    },
    'USE_SESSION_AUTH': False,
    'JSON_EDITOR': True,
    'JSON_REQUEST': True,
}

# ==================================
#   MSM SETTINGS
# ==================================
MCM_URL = 'http://192.168.1.206:8001/marketclearingmanager/mcm/'
ITLB_URL = 'http://192.168.1.206:8001/itlbfederatedlb/v1/'


# ONLY IN DEV SETTINGS
# DO NOT PUSH TO PRODUCTION
IB_URL = "http://localhost:5000"


# ==================================
#   LOGGING SETTINGS
# ==================================

LOGGING = {
    'version': 1,
    'disable_existing_loggers': True,
    'formatters': {
        'detailed': {
            'class': 'logging.Formatter',
            'format': "[%(asctime)s] - [%(name)s:%(lineno)s] - [%(levelname)s] %(message)s",
        }
    },
    'handlers': {
        'console': {
            'class': 'logging.StreamHandler',
            'level': 'DEBUG',
            'formatter': 'detailed',
        },
        'file': {
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': "{}/ib.log".format(BASE_DIR),
            'mode': 'w',
            'formatter': 'detailed',
            'level': 'DEBUG',
            'maxBytes': 2024 * 2024,
            'backupCount': 5,
        },
    },
    'loggers': {
        'ib': {
            'level': 'DEBUG',
            'handlers': ['console', 'file']
        },
    }
}
